//+------------------------------------------------------------------+
//|                                            MACrossBarCounter.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "*"
#property link      "*"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red
//---- input parameters
extern int FastMAPeriod=13;
extern int FastMAMethod=0; // 0-SMA, 1-EMA, 2-SMMA, 3-LWMA
extern int FastMAPrice=0; // 0-Close, 1-Open, 2-High, 3-Low, 4-Median, 5-Typical, 6-Weighted
extern int MoreFastMAPeriod=8;
extern int MoreFastMAMethod=0; // 0-SMA, 1-EMA, 2-SMMA, 3-LWMA
extern int MoreFastMAPrice=0; // 0-Close, 1-Open, 2-High, 3-Low, 4-Median, 5-Typical, 6-Weighted



//---- buffers
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   IndicatorDigits(0);
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){

         int limit=Bars-IndicatorCounted();

            for(int i=limit-1;i>=0;i--){

               ExtMapBuffer1[i]=ExtMapBuffer1[i+1];

               double fast_ma=iMA(NULL,0,FastMAPeriod,0,FastMAMethod,FastMAPrice,i);
               double more_fast_ma=iMA(NULL,0,MoreFastMAPeriod,0,MoreFastMAMethod,MoreFastMAPrice,i);
               
                  if(more_fast_ma>fast_ma){
                        if(ExtMapBuffer1[i]<0){
                           ExtMapBuffer1[i]=0;
                        }
                     ExtMapBuffer1[i]++;
                  }
                  if(more_fast_ma<fast_ma){
                        if(ExtMapBuffer1[i]>0){
                           ExtMapBuffer1[i]=0;
                        }
                     ExtMapBuffer1[i]--;
                  }                  
                  
               
            }
            
   return(0);
}
//+------------------------------------------------------------------+